/*
 * Created on Sep 18, 2004
 */
package org.tekkotsu.ui.editor.model.commands;

import org.eclipse.gef.commands.Command;
import org.tekkotsu.ui.editor.model.AbstractConnectionModel;
import org.tekkotsu.ui.editor.model.StateNodeModel;
import org.tekkotsu.ui.editor.model.LayoutData;
import org.tekkotsu.ui.util.Debugger;

/**
 * @author asangpet
 */
public class CreateConnectionCommand extends Command {
	private StateNodeModel source, target;
	private AbstractConnectionModel connection;
	private LayoutData contentsModel;
	
	public void setContentsModel(Object model) {
		contentsModel = (LayoutData) model;
	}
	
	@Override
	public boolean canExecute() {
		if (source == null || target == null)
			return false;
		
		return !source.equals(target);
	}
	
	/**
	 * Attach source/target and connection model to content model
	 */
	@Override
	public void execute() {
		Debugger.printDebug(Debugger.DEBUG_ALL,"Create connection command executed");
		connection.attachSource();
		connection.attachTarget();
		contentsModel.addChild(connection);		
	}
	
	public void setConnection(Object model) {
		connection = (AbstractConnectionModel) model;
	}
	
	public void setSource(Object model) {
		source = (StateNodeModel) model;
		connection.setSource(source);
	}
	
	public void setTarget(Object model) {
		target = (StateNodeModel) model;
		connection.setTarget(target);
	}
	
	@Override
	public void undo() {
		connection.detachSource();
		connection.detachTarget();
		contentsModel.removeChild(connection);
	}
}
