package org.tekkotsu.ui.editor.netcode;

import org.tekkotsu.ui.util.Debugger;

public class TimerTick {

	private RobotConnector conn;

	private long sysStartTime;
	private TimerThread thread;

	public TimerTick(RobotConnector conn) {
		this.conn = conn;
	}

	public void start() {
		sysStartTime = System.currentTimeMillis();
		resume();
	}

	public void stop() {
		if( thread != null ) {
			thread.running = false;
			thread = null;
		}
	}
	
	public void resume() {
		stop();
		thread = new TimerThread();
		thread.start();
	}
	
	public int elapsed() {
		return (int) (System.currentTimeMillis() - sysStartTime);
	}
	
	private class TimerThread extends Thread {
		public boolean running = true;
		
		@Override
		public void run() {
			while (running) {
				try {
					sleep(500);
					conn.props.firePropertyChange(
							RobotConnector.EVENT_TRACE_UPDATE_TIME, null,
							Integer.valueOf(elapsed()));
				} catch (InterruptedException e) {
					continue;
				}
			}
		}
	}

	public void sync(int time) {
		Debugger.printDebug("Syncing time to " + time);
		sysStartTime = System.currentTimeMillis() - time;
	}
}
